<?php

namespace XF2SEO\SEOPackage\Entity;

use XF\Mvc\Entity\Entity;
use XF\Mvc\Entity\Structure;

/**
 * COLUMNS
 * @property int|null keyword_id
 * @property string keyword
 * @property string replacement
 * @property string description
 * @property string target_url
 * @property array options
 * @property bool active
 * @property int created_date
 */
class Keyword extends Entity
{
    public static function getStructure(Structure $structure)
    {
        $structure->table = 'xf_seo_package_keyword';
        $structure->primaryKey = 'keyword_id';
        $structure->shortName = 'XF2SEO\SEOPackage:Keyword';

        $structure->columns = [
            'keyword_id' => ['type' => self::UINT, 'nullable' => true, 'autoIncrement' => true],
            'keyword' => ['type' => self::STR, 'required' => true, 'maxLength' => 100],
            'replacement' => ['type' => self::STR, 'default' => '', 'maxLength' => 255],
            'description' => ['type' => self::STR, 'default' => ''],
            'target_url' => ['type' => self::STR, 'default' => '', 'maxLength' => 255],
            'options' => ['type' => self::JSON_ARRAY, 'default' => []],
            'active' => ['type' => self::BOOL, 'default' => true],
            'created_date' => ['type' => self::UINT, 'default' => time()],
            'execute_order' => ['type' => self::UINT, 'default' => 10]
        ];

        return $structure;
    }
}
