<?php

namespace XF2SEO\SEOPackage\XF\Entity;

use XF2SEO\SEOPackage\App;
use XF\Mvc\Entity\Structure;
use XF2SEO\SEOPackage\Entity\Metadata;

class Thread extends XFCP_Thread
{
    /**
     * @param mixed $error
     * @return bool
     */
    public function canSEOPackageEdit(&$error = null): bool
    {
        return \XF::visitor()->hasNodePermission($this->node_id, 'seopackage_edit');
    }

    public function isSearchEngineIndexable(): bool
    {
        /** @var Metadata|null $entity */
        $entity = $this->getRelation(App::RELATION_METADATA);
        if ($entity !== null && $entity->isNoIndex()) {
            return false;
        }

        return parent::isSearchEngineIndexable();
    }

    protected function _postDelete()
    {
        parent::_postDelete();

        $entity = $this->getRelation(App::RELATION_METADATA);
        if ($entity !== null) {
            $entity->delete();
        }
    }

    public static function getStructure(Structure $structure)
    {
        $structure = parent::getStructure($structure);

        App::setupStructure($structure);
        $structure->defaultWith[] = App::RELATION_METADATA;

        return $structure;
    }
}
